// --------------------------------------------------------------------------------------
//
// Ablage.CS                                                       Ulrich Mller 27.06.04
//                                                                 PCS1700       C# Final
// Klassen fr die Ablage : Ablage48
// Ablage48 : Ablage mit vier/acht Ablagepltzen int Reihe mit Mittellcke (bei acht)
//
// --------------------------------------------------------------------------------------

using System;
using System.Drawing;

namespace PotiPatCS
{
	public class Ablage48 {
		private QCard32Pool qc;
		private int[] actCard; int NrCols, NrEmpty;
		private Card[] Cards;
		private int XBasis, YBasis, XBreite, CWidth;
		private int FCount;
		private SuitCode[] SuitList = 
            {SuitCode.Kreuz, SuitCode.Pik, SuitCode.Herz, SuitCode.Karo, 
			 SuitCode.Kreuz, SuitCode.Pik, SuitCode.Herz, SuitCode.Karo};

		public Ablage48(QCard32Pool QCard, int NrCols, int CardWidth, 
			int Left, int Top, int NrEmpty) {
			qc           = QCard;
			this.NrCols  = NrCols;
			XBasis       = Left;
			YBasis       = Top;
			CWidth       = CardWidth;
			this.NrEmpty = NrEmpty;
			XBreite      = CWidth * (NrCols + NrEmpty) - (CWidth - qc.CardWidth);
			actCard      = new int[NrCols];
			Cards        = new Card[NrCols];
			Clear();
		}
		public Ablage48(QCard32Pool QCard, int NrCols, int CardWidth, int Left, int Top) :
			this(QCard, NrCols, CardWidth, Left, Top, 0) {}

		// --- ColToX : Umrechung Spalten in Pixelkoordinaten ----------------
		public int ColToX(int Col) {
			return (Col > 3 ? Col + NrEmpty : Col) * CWidth + XBasis;
		}
		// --- Clear : Lschen der Ablage -------------------------------------
		public void Clear() {
			for(int i = 0; i < NrCols; i++) actCard[i] = -1;
			FCount = 0;
			Paint();
		}
		// --- CardCount : Gesamtanzahl karten in der Ablage ------------
		public int CardCount {
			get{return FCount;}
		}
		// --- Left/Top : Koordinaten der linken oberen Ecke -----------
		public int Left {
			get{return XBasis;}
		}
		public int Top {
			get{return YBasis;}
		}
		// --- Range : Bereichwerte von Ablage48 -----------------------
		public Rectangle Range {
			get{return new Rectangle(XBasis, YBasis, XBreite, qc.CardHeight);}
		}
		// --- XToCol : Bestimmung der zu X gehrenden Spalte -------------
		public int XToCol(int X) {
				int B = X - XBasis;
				if(B > (NrCols / 2 * CWidth)) B -= NrEmpty * CWidth;
				return (int)(B / CWidth);
		}
		// --- TopMostCard : oberste Karte der jeweiligen Spalte ------------
		public Card TopMostCard(int SrcCol) {
			return (actCard[SrcCol] < 0) ? null : Cards[SrcCol];
		}
		// --- AddCard : Anlegen von SrcCard auf der angegebenen Spalte ----
		public void AddCard(Card SrcCard, int DestCol) {
			actCard[DestCol]++;
			Cards[DestCol] = SrcCard;
			SrcCard.PicX = ColToX(DestCol);
			SrcCard.PicY = YBasis;
			SrcCard.Area = AreaCode.Ablage;
			SrcCard.PosC = DestCol;
			SrcCard.PosR = 0;
			qc.DealCard(SrcCard.CardNr, ColToX(DestCol), YBasis);
			SrcCard.Disabled = true;
			FCount++;
		}
		// --- Paint : Zeichnen des kartenbildes ------------------------
		public void Paint() {
			for(int i = 0; i < NrCols; i++) {
				if(actCard[i] < 0) qc.DrawSymbol(3, ColToX(i), YBasis);
				else qc.DrawCard(Cards[i].CardNr, Cards[i].PicX, YBasis);
			}
		}
		// --- IsAscendingSuit : Karte aufsteigend in gleicher Suit -----
		public bool IsAscendingSuit(Card SrcCard, int DestCol) {
			int Value; SuitCode VSuit;
			Card DestCard = TopMostCard(DestCol);

			if(DestCard == null) {
				VSuit = SuitList[DestCol];
				Value = 0;
			}
			else {
				VSuit = DestCard.Suit;
				Value = (int)DestCard.Value;
			}
			return ((VSuit == SrcCard.Suit) && ((Value + 1) == (int)SrcCard.Value)) 
				? true : false;
		}
		// --- IsDescending : Karte absteigend in der gleichen Suit -----------
		public bool IsDescendingSuit(Card SrcCard, int DestCol) {
			int Value; SuitCode VSuit;
			Card DestCard = TopMostCard(DestCol);

			if(DestCard == null) {
				VSuit = SuitList[DestCol];
				Value = 14;
			}
			else {
				VSuit = DestCard.Suit;
				Value = (int)DestCard.Value;
			}
			return ((VSuit == SrcCard.Suit) && ((Value - 1) == (int)SrcCard.Value)) 
				? true : false;
		}
	}
}
