// -------------------------------------------------------------------------------------
//
// Card.CS                                                        Ulrich Mller 23.06.04
//                                                                PCS1700       C# Final
// Klassen zur Beschreibung einer einzelnen Karte
// Bentigt QCard32Pool
//
// --------------------------------------------------------------------------------------

using System;

namespace PotiPatCS
{
	public struct CardPos {
		public int CardNr;
		public AreaCode Area;
		public int PicX;
		public int PicY;
		public int PosC;
		public int PosR;
		public int X;
		public int Y;
	}

	public class BaseCard {
		private int Nr;
		public BaseCard(int CardNr) {
			Nr = CardNr;
		}
		public int X {
			get{return QCard32Pool.GetCardXQC(Nr);}
			set{QCard32Pool.SetCardXQC(Nr, value);}
		}
		public int Y {
			get{return QCard32Pool.GetCardYQC(Nr);}
			set{QCard32Pool.SetCardYQC(Nr, value);}
		}
		public bool Blocked {
			get{return (QCard32Pool.GetCardBlockedQC(Nr) == 0) ? false : true;}
			set{QCard32Pool.AdjustCardBlockedQC(Nr, value ? 1 : 0);}
		}
		public ColorCode Color {
			get{return (ColorCode)QCard32Pool.GetCardColorQC(Nr);}
		}
		public bool Disabled {
			get{return (QCard32Pool.IsCardDisabledQC(Nr) == 0) ? false : true;}
			set{QCard32Pool.SetCardDisabledQC(Nr, value ? 1 : 0);}
		}
		public FaceCode Face {
			get{return (FaceCode)QCard32Pool.GetCardStatusQC(Nr);}
			set{QCard32Pool.SetCardStatusQC(Nr, value == FaceCode.FaceUp ? 1 : 0);}
		}
		public SuitCode Suit {
			get{return (SuitCode)QCard32Pool.GetCardSuitQC(Nr);}
		}
		public ValueCode Value {
			get{return (ValueCode)QCard32Pool.GetCardValueQC(Nr);}
		}
	}

	public class PoolCard : BaseCard {
		private int Nr;
		public PoolCard(int CardNr) : base(CardNr) {
			Nr = CardNr;
		}
		public bool User1 {
			get{return (QCard32Pool.GetUser1QC(Nr) == 0) ? false : true;}
			set{QCard32Pool.SetUser1QC(Nr, value ? 1 : 0);}
		}
		public int User2 {
			get{return QCard32Pool.GetUser2QC(Nr);}
			set{QCard32Pool.SetUser2QC(Nr, value);}
		}
		public int User3 {
			get{return QCard32Pool.GetUser3QC(Nr);}
			set{QCard32Pool.SetUser3QC(Nr, value);}
		}
		public int User4 {
			get{return QCard32Pool.GetUser4QC(Nr);}
			set{QCard32Pool.SetUser4QC(Nr, value);}
		}
	}

	public class Card : BaseCard {
		private int Nr, FX, FY;

		public Card(int CardNr, int Left, int Top) : base(CardNr) {
			Nr = CardNr;
			FX  = Left;
			FY = Top;
		}
		public Card(int CardNr) : this(CardNr, -72, -97) {}

		public int CardNr {
			get{return Nr;}
		}
		public int PicX {
			get{return FX;}
			set{FX = value;}
		}
		public int PicY {
			get{return FY;}
			set{FY = value;}
		}
		public AreaCode Area {
			get{return (AreaCode)QCard32Pool.GetUser2QC(Nr);}
			set{QCard32Pool.SetUser2QC(Nr, (int)value);}
		}
		public int PosC {
			get{return QCard32Pool.GetUser3QC(Nr);}
			set{QCard32Pool.SetUser3QC(Nr, value);}
		}
		public int PosR {
			get{return QCard32Pool.GetUser4QC(Nr);}
			set{QCard32Pool.SetUser4QC(Nr, value);}
		}
	}
}
