// --------------------------------------------------------------------------------------
//
// Keller.CS                                                       Ulrich Mller 25.06.04
//                                                                 PCS1700       C# Final
// Klassen fr den Keller : LiFoStack
//
// --------------------------------------------------------------------------------------

using System;
using System.Drawing;

namespace PotiPatCS
{
	public class LiFoStack
	{
		private QCard32Pool qc;
		private int actCard;
		private Card[] Cards = new Card[104];
		private int XBasis, YBasis, XBreite, XOffset;

		// --- Konstruktor : Alle Karten aufeinander --------
		public LiFoStack(QCard32Pool QCard, int Left, int Top){
			qc      = QCard;
			actCard = -1;
			XOffset = 0;
			XBasis  = Left;
			YBasis  = Top;
			XBreite = qc.CardWidth;
		}
		// --- Konstruktor : Karten nach rechts geschuppt -----
		public LiFoStack(QCard32Pool QCard, int MaxCards, int Left, int Top, int Width) {
			qc      = QCard;
			actCard = -1;
			XBasis  = Left;
			YBasis  = Top;
			XBreite = Width;
			XOffset = (int)((XBreite - qc.CardWidth)/(MaxCards - 1));
		}
		// --- Clear : Lschen des Kellers -----------------------------------
		public void Clear() {
			actCard = -1;
			Paint();
		}
		// --- Left / Top : Koordinaten der linken oberen Ecke -------
		public int Left {
			get{return XBasis;}
		}
		public int Top {
			get{return YBasis;}
		}
		// --- Range : Bereichswerte von LiFoStack ------
		public Rectangle Range {
			get{return new Rectangle(XBasis, YBasis, XBreite, qc.CardHeight);}
		}
		// --- TopMostCard : oberste Karte des Kellers --------------
		public Card TopMostCard() {
			return (actCard < 0) ? null : Cards[actCard];
		}
		// --- RemoveCard : Entfernen der obersten Karte des Kellers -----
		public Card RemoveCard() {
			if(actCard < 0) return null;
			qc.RemoveCard(Cards[actCard--].CardNr);
			if(actCard >= 0) Cards[actCard].Disabled = false;
			return Cards[actCard+1];
		}
		// --- AddCard : SrcCard auf dem Keller ablegen -----------------
		public void AddCard(Card SrcCard) {
			Cards[++actCard] = SrcCard;
			SrcCard.PicX = actCard * XOffset + XBasis;
			SrcCard.PicY = YBasis;
			SrcCard.Area = AreaCode.Keller;
			SrcCard.PosC = 0;
			SrcCard.PosR = actCard;
			if(actCard > 0) Cards[actCard-1].Disabled = true;
			qc.DealCard(SrcCard.CardNr, SrcCard.PicX, YBasis);
			SrcCard.Disabled = false;
		}
		// --- Paint : Zeichnen des Kartenbildes ---------------------------
		public void Paint() {
			if(actCard < 0) qc.DrawSymbol(3, XBasis, YBasis);
			else for(int i = 0; i <= actCard; i++)
					 qc.DrawCard(Cards[i].CardNr, Cards[i].PicX, Cards[i].PicY);
		}

	}
}
