// -------------------------------------------------------------------------------------
//
// PotiPat.CS                                                     Ulrich Mller 23.06.04
//                                                                PCS1700       C# Final
// Abstrakte Klasse fr die Spiellogik einer Patience
//
// -------------------------------------------------------------------------------------

using System;

namespace PotiPatCS
{

	public enum AreaCode {
		none    = 0, Ablage  = 1, Auslage = 2, Keller  = 3, Talon   = 4
	}
	public abstract class PotiPatience
	{
		protected enum DragCode {none = 0, One = 1, Block = 2}
		protected QCard32Pool qc;
		protected System.Windows.Forms.Form FCanvas;
		protected DragCode DragMode = DragCode.none;

		public PotiPatience(System.Windows.Forms.Form Canvas, 
			int BackNr, int Offset) {
			FCanvas = Canvas;
			qc = new QCard32Pool(FCanvas.Handle, BackNr, Offset);
		}
		public PotiPatience(System.Windows.Forms.Form Canvas) : this(Canvas, 1, 20) {}

		// --- Back : Kartenrckseite -----------------------------
		public int Back {
			get{return qc.BackNr;}
			set{qc.BackNr = value;}
		}

		// --- SpielStarten : Initwerte, Mischen, Auslegen ------------
		public abstract void SpielStarten(int SpielNr);

		// --- Refresh : Wiederherstellen (Paint) des aktuellen Kartenbildes ---
		public abstract void Refresh();

		// --- StartZiehen : Starten des Ziehens einer Karte ----
		public abstract void StartZiehen(int X, int Y);

		// --- WeiterZiehen : Fortsetzen des Ziehens einer Karte -------
		public abstract void WeiterZiehen(int X, int Y);

		// --- EndeZiehen : Beenden des Ziehens, Ablegen / Rcklegen ----
		public abstract void EndeZiehen(int X, int Y);

		// --- KarteAblegen : Prfen und ggf. Ablegen -------------
		public abstract void KarteAblegen();
	}
}
