// ------------------------------------------------------------------------------------
//
// QC32Test.CS                                                   Ulrich Mller 23.06.04
//                                                               PCS1700       C# Final
// Testrahmen fr Klasse QCard32Pool
// 
// ------------------------------------------------------------------------------------

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using PotiPatCS;

namespace QCard32TestCS
{
	public class frmMain : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button cmdAction;
		private System.ComponentModel.Container components = null;

		public frmMain()
		{
			InitializeComponent();

		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.cmdAction = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// cmdAction
			// 
			this.cmdAction.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.cmdAction.BackColor = System.Drawing.SystemColors.Control;
			this.cmdAction.Location = new System.Drawing.Point(476, 484);
			this.cmdAction.Name = "cmdAction";
			this.cmdAction.Size = new System.Drawing.Size(104, 24);
			this.cmdAction.TabIndex = 0;
			this.cmdAction.Text = "&ACTION";
			this.cmdAction.Click += new System.EventHandler(this.cmdAction_Click);
			// 
			// frmMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.Color.ForestGreen;
			this.ClientSize = new System.Drawing.Size(600, 525);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.cmdAction});
			this.Name = "frmMain";
			this.Text = "PotiPatCS : QCard32Test";
			this.Load += new System.EventHandler(this.frmMain_Load);
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.frmMain_Paint);
			this.ResumeLayout(false);

		}
		#endregion

		QCard32Pool qc;
		KartenPaket Talon;
		LiFoStack   Keller;
		AuslageV    Auslage;
		Ablage48    Ablage;
		bool firstTime = true;

		[STAThread]
		static void Main() 
		{
			Application.Run(new frmMain());
		}

		private void frmMain_Load(object sender, System.EventArgs e)
		{
			try
			{
				qc = new QCard32Pool(this.Handle);
			}
			catch (QCard32Exception eqc)
			{
				MessageBox.Show(eqc.Message, "QC32Test", MessageBoxButtons.OK, 
					MessageBoxIcon.Error);
				this.Close();
			}
	//		QCard32Pool.SetOffSet(CardFace.Offset);
		}

		private void cmdAction_Click(object sender, System.EventArgs e)
		{
			Card SrcCard;
			Talon = new KartenPaket(qc, 1, 16, 16);
			Keller = new LiFoStack(qc, 16 + qc.CardWidth + 12, 16);
			Ablage = new Ablage48(qc, 4, qc.CardWidth + 12, 
				16 + ((qc.CardWidth + 12) * 3), 16);
			Auslage = new AuslageV(qc, 8, 
				qc.CardWidth + 12, 16, 16 + qc.CardHeigthS, 500);
			
			Talon.NewDeck(4);
			Auslage.Clear();
			int OG = 0;
			for(int i = 0; i <= 6; i++) {
				for(int j = 0; j <= OG; j++) {
					SrcCard = Talon.RemoveCard();
					if (j == OG) Auslage.AddCard(SrcCard, i, FaceCode.FaceUp);
					else {
						Auslage.AddCard(SrcCard, i, FaceCode.FaceDown);
						SrcCard.Disabled = true;
					}
				}
				OG++;
			}
			firstTime = false;
		}

		private void frmMain_Paint(object sender, System.Windows.Forms.PaintEventArgs e) {
			if(firstTime) return;
			Zeichnen();
		}
		private void Zeichnen() {
			Talon.Paint();
			Keller.Paint();
			Auslage.Paint();
			Ablage.Paint();
		}
	}
}
