// ---------------------------------------------------------------------------------------
//
// Talon.CS                                                         Ulrich Mller 24.06.04
//                                                                  PCS1700       C# Final
// Klassen fr Kartenpaket und Talon : KartenPaket
// Bentigt QCardPool
//
// ---------------------------------------------------------------------------------------

using System;
using System.Drawing;

namespace PotiPatCS
{
	public class KartenPaket
	{
		private QCard32Pool qc;
		private int FID;
		private int actCard, anzCards;
		private Card[] Cards;
		private int XBasis, YBasis;
		private const int EmptySymbol = 2;

		public KartenPaket(QCard32Pool QCard, int NrPacks, int Left, int Top) {
			FID = 0;
			qc = QCard;
			actCard = -1;
			anzCards = (NrPacks == 1) ? 52 : 104;
			Cards = new Card[anzCards];
			XBasis = Left;
			YBasis = Top;
		}
		public int Left {
			get{return XBasis;}
		}
		public int Top {
			get{return YBasis;}
		}
		public Rectangle Range {
			get{return new Rectangle(XBasis, YBasis, qc.CardWidth, qc.CardHeight);}
		}
		public int ID {
			get{return FID;}
		}
		public int CardCount {
			get{return actCard + 1;}
		}
		public Card TopMostCard() {
			return (actCard < 0) ? null : Cards[actCard];
		}
		public Card RemoveCard(FaceCode Face) {
			if(actCard < 0) return null;
			Cards[actCard].Face = Face;
			qc.RemoveCard(Cards[actCard].CardNr);
			return Cards[actCard--];
		}
		public Card RemoveCard() {
			return RemoveCard(FaceCode.FaceUp);
		}
		public void AddCard (Card SrcCard){
			Cards[++actCard] = SrcCard;
			SrcCard.PicX = XBasis;
			SrcCard.PicY = YBasis;
			SrcCard.Area = AreaCode.Talon;
			SrcCard.PosC = 0;
			SrcCard.PosR = actCard;
			SrcCard.Face = FaceCode.FaceDown;
			qc.DealCard(SrcCard.CardNr, XBasis, YBasis);
		}
		public void NewDeck(int ID) {
			int[] CardNrs = new int[anzCards];
			Random r = new Random(ID);
			
			FID = ID;
			for(int i=0; i<anzCards; i++) CardNrs[i] = i+1;
			if (FID != 1) {
				for(int i = 0; i < 10; i++)
					for(int j = 0; j < anzCards; j++) {
						int ks      = r.Next(0, anzCards-1);
						int sw      = CardNrs[j];
						CardNrs[j]  = CardNrs[ks];
						CardNrs[ks] = sw;
					}
			}
			QCard32Pool.SetDefaultValuesQC();
			QCard32Pool.SetCurrentBackQC(qc.BackNr);
			QCard32Pool.SetOffSetQC(qc.Offset);
			qc.DrawSymbol(EmptySymbol, XBasis, YBasis);
			for(int i = 0; i < anzCards; i++) {
				Cards[i] = new Card(CardNrs[i]);
				Cards[i].PicX = XBasis;
				Cards[i].PicY = YBasis;
				Cards[i].Area = AreaCode.Talon;
				Cards[i].PosC = 0;
				Cards[i].PosR = i;
				Cards[i].Face = FaceCode.FaceDown;
				qc.DealCard(Cards[i].CardNr, XBasis, YBasis);
			}
			actCard = anzCards - 1;
		}
		public void Paint() {
			if (actCard < 0) qc.DrawSymbol(EmptySymbol, XBasis, YBasis);
			else qc.DrawBack(qc.BackNr, XBasis, YBasis);
		}
	}
}
